####################################
# All Rights Reserved
# Copyright (c) 2022-2023 fixyldev
####################################

#register
execute as @r unless score @s lastdeathlocation.registered matches 1 run tellraw @s ["","\n",{"text":"Last Death Location - 0.3.0","color":"red"},"\n","\n",{"text":"   /trigger lastdeathlocation","color":"gold","clickEvent":{"action":"suggest_command","value":"/trigger lastdeathlocation"}},"\n",{"text":"      shows your \"Last Death Location\" in the chat","color":"yellow"},"\n",{"text":"   /trigger lastdeathlocation.settings","color":"gold","clickEvent":{"action":"suggest_command","value":"/trigger lastdeathlocation.settings"}},"\n",{"text":"      shows the settings menu in the chat","color":"yellow"},"\n","\n",{"text":"Otherwise, the location will be displayed in the chat after death.","color":"yellow"},"\n"]
execute as @r unless score @s lastdeathlocation.registered matches 1 run scoreboard players set @s lastdeathlocation.registered 1

#gamerule
execute unless score #doImmediateRespawn lastdeathlocation.gamerule matches 0..1 store result score #doImmediateRespawn lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute store result score #doImmediateRespawn.check lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute if score #doImmediateRespawn.check lastdeathlocation.gamerule matches 1 run gamerule doImmediateRespawn false

#marker
execute as @a[scores={lastdeathlocation.death=1..}] at @s align xyz run summon area_effect_cloud ~0.5 ~0.5 ~0.5 {CustomNameVisible:1b,Duration:6000,Tags:["lastdeathlocation"],CustomName:'{"translate":"deathScreen.title","italic":true}'}
execute at @e[tag=lastdeathlocation] run particle minecraft:firework ~ ~ ~ 0.2 0.2 0.2 0.025 1 normal
execute as @e[tag=lastdeathlocation] at @s if entity @p[distance=..5,gamemode=!spectator] unless entity @p[distance=..5,nbt={Health:0f}] run particle minecraft:totem_of_undying ~ ~1 ~ 0.2 0 0.2 0.1 25
execute as @e[tag=lastdeathlocation] at @s if entity @p[distance=..5,gamemode=!spectator] unless entity @p[distance=..5,nbt={Health:0f}] run playsound minecraft:entity.experience_orb.pickup player @a[distance=..20] ~ ~ ~ 1 1 1
execute as @e[tag=lastdeathlocation] at @s if entity @p[distance=..5,gamemode=!spectator] unless entity @p[distance=..5,nbt={Health:0f}] run kill @s

#lastdeathlocation.manual
scoreboard players enable @a lastdeathlocation
execute as @r[scores={lastdeathlocation=..-1}] run scoreboard players set @s lastdeathlocation 1
execute as @r[scores={lastdeathlocation=1..}] run function lastdeathlocation:chat/message

#lastdeathlocation
execute as @a[scores={lastdeathlocation.death=1..}] run function lastdeathlocation:chat/message

#settings
scoreboard players enable @a lastdeathlocation.settings
execute as @r[scores={lastdeathlocation.settings=..-1}] run scoreboard players set @s lastdeathlocation.settings 1
execute as @r[scores={lastdeathlocation.settings=1..}] run function lastdeathlocation:chat/settings
